config/routes.rb
Rails.application.routes.draw do
  resources :articles
  resources :categories
  resources :vats
  resources :projects
  resources :users
  resources :interventions
  resources :partners

  root 'partners#index'

  resource :user_sessions, only: [:create, :new, :destroy]

  get 'logout' => 'user_sessions#destroy', :as => :logout

  get 'login' => 'user_sessions#login', :as => :login

  post 'get_token' => 'user_sessions#get_token'

  get 'partners/:id/interventions' => 'partners#interventions'

	get 'partners/:id/projects' => 'partners#projects'

  get 'users/:id/interventions' => 'users#interventions'

  get 'config/' => 'config#index'

  get 'about/' => 'about#index'

end

app/models/partner.rb
class Partner < ActiveRecord::Base
  has_many :projects
  has_and_belongs_to_many :interventions
  has_attached_file :logo, styles: { medium: "300x300>", thumb: "100x100>", mini: "50x50" }, default_url: "/assets/nologo_:style.png"
  validates_attachment_content_type :logo, :content_type => /\Aimage\/.*\Z/

  def interventions
    return Intervention.joins(:project).where("projects.partner_id=?", self.id)
  end

end

app/controllers/partners_controller.rb
class PartnersController < ApplicationController
  before_action :set_partner, only: [:show, :edit, :update, :destroy, :interventions, :projects]

  # GET /partners
  # GET /partners.json
  def index
    @partners = Partner.order(:name)
		@partners = @partners.where(supplier: params['suppliers'].to_i) if params['suppliers']
		@partners = @partners.where(customer: params['customers'].to_i) if params['customers']
  end

  # GET /partners/1
  # GET /partners/1.json
  def show
    @interventions = Intervention.joins(:project).where("projects.partner_id=?", @partner.id).order("intervention_date DESC")
    @projects = Project.where(partner_id: @partner.id)
  end

  # GET /partners/new
  def new
    @partner = Partner.new
  end

  # GET /partners/1/edit
  def edit
  end

  # POST /partners
  # POST /partners.json
  def create
    @partner = Partner.new(partner_params)

    respond_to do |format|
      if @partner.save
        format.html { redirect_to @partner, notice: 'Le partenaire a bien été créé.' }
        format.json { render :show, status: :created, location: @partner }
      else
        format.html { render :new }
        format.json { render json: @partner.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /partnesr/1
  # PATCH/PUT /partners/1.json
  def update
    respond_to do |format|
      if @partner.update(partner_params)
        format.html { redirect_to @partner, notice: 'Le partenaire a bien été modifié.' }
        format.json { render :show, status: :ok, location: @partner }
      else
        format.html { render :edit }
        format.json { render json: @partner.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /partners/1
  # DELETE /partners/1.json
  def destroy
    @partner.destroy
    respond_to do |format|
      format.html { redirect_to partners_url, notice: 'Le partenaire a été supprimé.' }
      format.json { head :no_content }
    end
  end

  # GET /partners/1/interventions.json
  def interventions
    @interventions = Intervention.where(partner_id: @partner.id).order("intervention_date DESC")
  end

	# GET /partners/1/projects.json
  def projects
    @projects = Project.where(partner_id: @partner.id)
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_partner
      @partner = Partner.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def partner_params
      params.require(:partner).permit(:name, :email, :tel, :mobile, :fax, :address, :lat, :long, :notes, :logo, :supplier, :customer)
    end
end

app/helpers/partners_helper.rb
module PartnersHelper
end

app/views/partners/_form.html.erb
<%= form_for(@partner) do |f| %>

  <% if @partner.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@partner.errors.count, "error") %> prohibited this partner from being saved:</h2>

      <ul>
      <% @partner.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field input-group">
		<span class="input-group-addon"><i class="fa fa-camera fa-fw"></i></span>
		<%= f.file_field :logo %>
	</div>
  <div class="control-group">
    <div class="field input-group">
      <span class="input-group-addon" title="Nom"><i class="fa fa-user fa-fw"></i></span>
      <%= f.text_field :name, class: "form-control", placeholder: "Nom" %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Email"><i class="fa fa-envelope fa-fw"></i></span>
      <%= f.text_field :email, class: "form-control", placeholder: "Email" %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Téléphone fixe"><i class="fa fa-phone fa-fw"></i></span>
      <%= f.text_field :tel, class: "form-control", placeholder: "Téléphone fixe" %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Téléphone mobile"><i class="fa fa-mobile fa-fw"></i></span>
      <%= f.text_field :mobile, class: "form-control", placeholder: "Téléphone mobile" %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Fax"><i class="fa fa-fax fa-fw"></i></span>
      <%= f.text_field :fax, class: "form-control", placeholder: "Fax" %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Adresse postale"><i class="fa fa-map-marker fa-fw"></i></span>
      <%= f.text_area :address, class: "form-control", placeholder: "Adresse postale" %>
    </div>
  </div>
  <div class="col-md-6">
    <div class="control-group">
  	  <div class="field input-group">
  			<span class="input-group-addon" title="Latitude"><i class="fa fa-globe fa-fw"></i></span>
        <%= f.text_field :lat, class: "form-control", placeholder: "Latitude" %>
      </div>
    </div>
  </div>
  <div class="col-md-6">
    <div class="control-group">
  	  <div class="field input-group">
  			<span class="input-group-addon" title="Longitude"><i class="fa fa-globe fa-fw"></i></span>
        <%= f.text_field :long, class: "form-control", placeholder: "Longitude" %>
      </div>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Notes"><i class="fa fa-pencil fa-fw"></i></span>
      <%= f.text_area :notes, class: "form-control", placeholder: "Notes" %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span title="Fournisseur ?">Fournisseur ? </span>
      <%= f.check_box :supplier, value: @partner.supplier  ? 1 : 0, class: "my-checkbox" %>
    </div>
	</div>
	<div class="control-group">
	  <div class="field input-group">
			<span title="Client ?">Client ? </span>
      <%= f.check_box :customer, value: @partner.customer  ? 1 : 0, class: "my-checkbox" %>
    </div>
	</div>
  <div class="actions">
    <%= f.submit "Valider", class: "btn btn-primary" %> ou
    <%= link_to 'Retour', partners_path %>
  </div>
<% end %>

app/views/partners/edit.html.erb
<div class="titre_actif">
  <h1>Modifier un utilisateur</h1>
  <span class="title-tag">
    <i class="fa fa-users fa-4x"></i>
  </span>
</div>

<%= render 'form' %>

app/views/partners/index.html.erb
<div class="titre_actif">
  <div class="toolbar">
    <%= link_to new_partner_path, class: "btn btn-primary" do %>
      <i class="fa fa-plus fa-3x"></i>
    <% end %>
  </div>
  <h1>Partenaires</h1>
  <span class="title-tag">
    <i class="fa fa-users fa-4x"></i>
  </span>
</div>

<table id="table"
     data-classes="table table-hover table-condensed"
     data-striped="true"
     data-toolbar="#toolbar"
     data-pagination="true"
     data-click-to-select="false"
     data-search="true"
     data-show-export="true"
     data-reorderable-columns="true"
     data-show-refresh="true"
     data-show-pagination-switch="true">
  <thead>
    <tr>
      <th></th>
      <th>Nom</th>
      <th>Email</th>
      <th>Tél</th>
      <th>Mobile</th>
      <th></th>
      <th></th>
      <th></th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @partners.each do |partner| %>
      <tr>
        <td>
          <%= link_to image_tag(partner.logo.url(:mini)), partner_path(partner) %>
        </td>
        <td>
          <%= partner.name %>
          <span class="cell-icon">
            <a href="<%= partner_path(partner) %>"><i class="fa fa-external-link"></i></a>
          </span>
        </td>
        <td><%= partner.email %></td>
        <td><%= partner.tel %></td>
        <td><%= partner.mobile %></td>
        <td>
          <%= link_to partner_path(partner) do %>
             <%= partner.interventions.count %><i class="fa fa-clock-o fa-fw"></i>
          <% end %>
          <span class="cell-icon">
            <%= link_to new_intervention_path(partner_id: partner.id) do %>
              <i class="fa fa-plus"></i></a>
            <% end %>
          </span>
        </td>
        <td>
          <%= link_to partner_path(partner) do %>
            <i class="fa fa-file-text fa-fw"></i>
          <% end %>
          <%= link_to partner_path(partner) do %>
            <i class="fa fa-globe fa-fw"></i>
          <% end %>
        </td>
        <td>
          <%= link_to partner_path(partner) do %>
            <%= partner.projects.count %><i class="fa fa-briefcase fa-fw"></i>
          <% end %>
          <span class="cell-icon">
            <%= link_to new_project_path(partner_id: partner.id) do %>
              <i class="fa fa-plus"></i></a>
            <% end %>
          </span>
        </td>
        <td>
          <%= link_to partner, method: :delete, data: { confirm: 'Are you sure?' } do %>
            <i class="fa fa-trash fa-fw"></i>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/partners/new.html.erb
<div class="titre_actif">
  <h1>Nouveau client</h1>
</div>

<%= render 'form' %>

app/views/partners/show.html.erb
<div class="titre_actif">
  <div class="toolbar">
    <%= link_to edit_partner_path(@partner), class: "btn btn-primary" do %>
      <i class="fa fa-pencil fa-3x"></i>
    <% end %>
  </div>
  <h1><%= @partner.name %></h1>
  <span class="title-tag">
    <i class="fa fa-user fa-4x"></i>
  </span>
</div>

<div class="col-md-4">
  <%= image_tag @partner.logo(:medium) %>
</div>
<div class="col-md-4">
  <div class="well left">
    <strong>Tél: </strong><%= @partner.tel %></br>
    <strong>Mobile: </strong><%= @partner.mobile %></br>
    <strong>Fax: </strong><%= @partner.fax %></br>
    <strong>Adresse: </strong><%= @partner.address %></br>
  </div>
</div>
<div class="col-md-4">
  <% if @partner.lat and @partner.long %>
    <a target="_blank" href="http://www.openstreetmap.org/?mlat=<%=@partner.lat%>&mlon=<%==@partner.long%>#map=18/<%==@partner.lat%>/<%==@partner.long%>">
      <%= image_tag "location-icon.svg", height: "100px" %>
    </a>
  <% end %>
</div>

<div class="col-md-12">
  <div class="tabbable-panel">
  	<div class="tabbable-line">
  		<ul class="nav nav-tabs ">
        <li class="active">
  				<a href="#tab_projects" data-toggle="tab">
  				Projets/Contrats </a>
  			</li>
  			<li>
  				<a href="#tab_interventions" data-toggle="tab">
  				Interventions </a>
  			</li>
  			<li>
  				<a href="#tab_notes" data-toggle="tab">
  				Notes </a>
  			</li>
  		</ul>
  		<div class="tab-content">
        <div class="tab-pane active" id="tab_projects">
          <%= render 'projects/tables_projects' %>
  			</div>
  			<div class="tab-pane" id="tab_interventions">
  				<%= render 'interventions/tables_interventions' %>
  			</div>
  			<div class="tab-pane" id="tab_notes">
          <div class="well left">
  		      <%= simple_markdown(@partner.notes) %>
          </div>
  			</div>
  		</div>
  	</div>
  </div>
</div>